/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */

import "package:dio/dio.dart" show Dio;
import "package:flutter/material.dart";
import "package:flutter_ume_plus/flutter_ume_plus.dart";

import "models/http_interceptor.dart";
import "widgets/icon.dart" as icon;
import "widgets/pluggable_state.dart";

// TODO(Alex): Implement [PluggableStream] for dot features.
/// Implement a [Pluggable] to integrate with UME.
class DioInspector extends StatefulWidget implements Pluggable {
  DioInspector(
      {super.key,
      required this.dio,
      this.nav,
      this.themeData,
      this.themeMode}) {
    dio.interceptors.add(UMEDioInterceptor());
  }

  final NavigatorState? nav;
  final Dio dio;
  final ThemeData? themeData;
  final ThemeMode? themeMode;

  @override
  DioPluggableState createState() => DioPluggableState();

  @override
  ImageProvider<Object> get iconImageProvider => MemoryImage(icon.iconBytes);

  @override
  String get name => "网络日志";

  @override
  String get displayName => "网络日志";

  @override
  void onTrigger() {}

  @override
  Widget buildWidget(BuildContext? context) => this;
}
